'FFSubmenu=Dokumentation
'FFName=Bilderinfo nach Excel

'FFSkriptName=ImageInfo_To_Excel.vbs
'FFSkriptArchiv=ImageInfo_To_Excel.zip
'FFSkriptDirectory=
'FFSkriptFiles=
'FFScriptProfile=FF_Doku-Excel

'FFSkriptAuthor=Harald Maeckler
'FFSkriptVersion=4.12
'FFVersion=2.90.0
'FFSkriptURL=http://www.meckis-steckenpferde.de/FixFoto_Skripte.html
' ***********************************************************************
' ImageInfo_To_Excel.vbs (Script fr FixFoto)
'
' Funktion:     Schreibt Dateinamen mit ausgewhlten Zusatzinformationen
'				in eine neue Excel-Tabelle
'
' Version 4.12 vom 29.03.2016 - Skript-URL gem Forenberarbeitung gendert
' Version 4.11 vom 18.04.2014 - Spalte "Schlagwrter" wird fr Zeilenumbruch konditioniert
'									wenn bei "Kommentar / Schlagwrter" Option "einzeilig" aktiv ist
' Version 4.10 vom 02.04.2014 - Alle Exif- bzw. IPTC-Daten knenn alternierend mit einem Knopfdruck
'									aktiviert und deaktiviert werden
'							  - Updatefunktion aktualisiert
' Version 4.09 vom 19.11.2013 - Codepage (Zeichensatztabelle) frei whlbar
' Version 4.08 vom 17.11.2013 - bertragen von Blende, Bel.-Korrektur und Brennweite als Zahl
'							  - Mapping nur 1x ermitteln (Geopage 28605 fr ISO-8859-15)
' Version 4.07 vom 14.11.2013 Geodaten optional in Dezimalwerten ausgeben (ohne Hhenangabe)
' Version 4.06 vom 06.05.2012 - lngste Seite fr Thumbnaileintrge vorgebbar in px
'							  - Updatefunktion eingebaut
'							  - Tooltips eingetragen
'							  - Kurzbeschreibung als PDF-Datei
' Version 4.05 vom 06.01.2011 Schnheitsfehler beseitigt
' Version 4.04 vom 24.03.2011 Bug bei Erststart in der Registry beseitigt
' Version 4.03 vom 23.03.2011 mit Mapping der IPTC-Daten
' Version 4.02 vom 14.03.2011 Blendenwerte mit Komma statt Punkt werden korrigiert
' Version 4.01 vom 13.03.2011 Kommentar und Schlagwrter wahlweise ein- oder mehrzeilig
' Version 4.00 vom 13.03.2011 - Exif-Date Bildbeschreibung hinzu
'							  - IPTC-Daten hinzu
' Version 3.11 vom 08.08.2010 Namensfilter eingefhrt
' Version 3.10 vom 09.06.2010 Bug bei diversen Zahlenformaten beseitigt
' Version 3.09 vom 15.01.2010 Bugs bei 'Thumbnaileintrag' beseitigt
' Version 3.08 vom 14.01.2010 Option 'Thumbnaileintrag als Kommentar' hinzu
' Version 3.07 vom 11.07.2009 Lschroutine hinzugefgt und KB entsprechend ergnzt
' Version 3.06 vom 15.06.2009 Bug bei Brennweitenformatierung beseitig
'							  Ausrichtung nachgetragen am 16.06.2009
' Version 3.05 vom 14.06.2009 Formatierung der Brennweitenwerte gendert
' Version 3.04 vom 13.06.2009 Brennweite wahlweise im Original und/oder KB-Wert
' Version 3.03 vom 14.03.2009 Geodaten hinzugefgt
' Version 3.02 vom 20.07.2008 Bug bei Kommentar nur mit Steuerzeichen beseitigt
' Version 3.01 vom 18.07.2008 berschriften und andere Werte parametrisiert
' Version 3.00 vom 17.07.2008 Kommentarspalte ein- oder mehrz. hinzu
' Version 2.05 vom 15.07.2008 Anzeigebugs beseitigt
' Version 2.04 vom 03.12.2007 Erluterungen hinzu, abfragbar ber ?
'							  Stand.-Button fr Bildfilter hinzugefgt
'							  "Standard"-Button umbenannt in "Alle Daten"
' Version 2.03 vom 27.10.2007 Bug in Arraygre beseitigt
' Version 2.02 vom 20.08.2007 Bug beseitigt + Gesamtpixelzahl hinzugefgt
' Version 2.01 vom 10.07.2007 Blattformatierung abschaltbar
'							  Exif-Daten um EV-Korrektur ergnzt
'							  nderung der Brennw.-Ermittlung
' Version 2.00 vom 14.06.2007 schnellere bertragung zur Excel-Tabelle
'							 	ber ein Array
'							  Dateierfassung auch ber Unterverz. mglich
' Version 1.08 vom 16.04.2007 Fehlanzeige bei defekter ExifDatei beseitigt
' Version 1.07 vom 04.04.2007 mit Brennw.-Def. fr eine Kamera
' Version 1.06 vom 24.01.2007 mit vorgeschaltetem Dialog mit Bildfilter
'  
' Copyright (C) Harald Maeckler, Dsseldorf

'** Start Kurzbeschreibung *******************************************
' ImageInfo to Excel / Version 4.12
' ====================
'
' Das Skript bertrgt die ausgewhlten Daten in ein Excel-Tabellenblatt.

' Einstellungen
' ----------------
' - ausgewhlte Bilder
' - alle Bilder gem Bildfilter (s.unten)
' - alle Dateien
' Bei 'alle Bilder' und 'alle Dateien' knnen auf Wunsch die Unterverzeich-
' nisse einbezogen werden.
'
' Blattformat
' -------------
' Es ist whlbar, ob eine Formatierung erfolgt.
' - Hoch- oder Querfomat ist mglich.
' - Die Seitenrnder knnen zwischen 0,5 und 2,5 cm festgelegt werden.
' - Die Tabelle kann auf Wunsch mit einem Gitter versehen werden.
'
' Filterungen
' --------------
' - Die Filter knnen beliebig editiert werden.
' - Beim Bildfilter wird mit (S)tandard wieder der Filter 'BMP-JP2-JPG-JPEG-PNG-TIF' 
'   hergestellt.
' - Wenn der Namensfilter aktiviert ist, werden nur Dateien bearbeitet, deren
'   Namen den Filtertext beinhalten. Dabei wird Gro- und Kleinschreibung berck-
'   sichtigt.
'
' Codepage
' --------------
' Fr verschiedene Sprachrume kann die Codepagenorm gewhlt werden.
' Wenn 'Auto' zu falschen Umlauten und Sonderzeichen fhrt, dann die anderen
' Einstellungen testen.
'
' Thumbnaileintrag als Kommentar (ab Excel 2000)
' ----------------------------------------------------------
' In die Excelzellen der Bildernamen wird das dazugehrige Thumbnail als Kommentar
' eingetragen. Die Gre der lngsten Seite des Thumbnails kann in px vorgegeben
' werden und muss mindestens 100 px und hchstens 400 px betragen.
' Zeigt man in der fertigen Tabelle mit dem Mauscursor auf einen Bildernamen wird
' das Thumnnail angezeigt.
'
' Allgemein
' ------------
' 'x' oben rechts bricht das Skript ab.
' '?' zeigt die vorliegende Erluterung an.
' 'Alle Daten' whlt alle Daten aus.
' 'OK' startet die Ausgabe der Daten.
'
' Deinstallation
' ========
' Wird die Entfernung des Skripts gewnscht, kann mit der Tastenkombination Alt + D
' eine Lschroutine aufgerufen werden. Nach einer Sicherheitsabfrage wird berprft,
' ob das zugehrige zip-Archiv im Skriptordner abgelegt ist. Wenn ja, wird vor dem
' Lschen angeboten, davon eine Sicherheitskopie an einem beliebigen Speicherort ab-
' zulegen. Danach werden nacheinander die Skriptdatei, die in der Registry dazuge-
' hrenden Daten und eventuelle Zusatzdateien gelscht. Abschlieend wird die 
' FixFotoScript.ini bereinigt.
' Nach manueller Durchfhrung einer 'Automatischen Skriptkonfiguration' ist das Skript
' mit allen Komponenten aus der FixFoto-Umgebung entfernt.
'
'
' Benutzung des Skripts auf eigene Gefahr!
'
' Copyright Harald Maeckler
'** Ende Kurzbeschreibung ***********************************************

Option Explicit

' ***********************************************************************
' ++++++       Einstellparameter     ++++++++++++++++++++++++++++++++++++
' ***********************************************************************

'Konstante fr Exif und IPTC Ein/Aus
const EDat = "EKam/EAuD/EGrP/EBld/EBeZ/EKorr/EBrw/EBlz/EISO/EKomm/EGeo/EBeschr"
const IDat = "IUeber/IAutor/IObjN/IObjB/IKat/ICop/IFot/ILand/IReg/IOrt/IOTeil/ISchlW"
Dim EDat_Array,IDat_Array,EI_Date
EDat_Array = split(EDat,"/") : IDat_Array = split(IDat,"/")

'Geopage-Einstellung
Dim CodeP_Wert,CodeP_Auswahl,CodePa_Array,CodePw_Array,CodePelement,MappMerker
Const CodePwerte   = "Auto/MacRoman/UTF-8/US-ASCII/ISO-8859-1/ISO8859-15"
Const CodePauswahl = "Auto/10000/65001/10127/28591/28605"

'Standardfilter fr 'Alle Bilder'
'---------------------------------
Const BildKenn = "BMP-JP2-JPG-JPEG-PNG-TIF"		'Standard erlaubter BildKennungen

'Einstellparameter fr die Ablaufanzeige
'---------------------------------------
Const ProzWert = 5								'Erhhungswert des Prozentsatz zur Anzeige

'Text fr leere Zellen
'---------------------
Const StrLeer = "---"							'kann auch "n.v." (nicht vorhanden) oder "" (nichts) sein

'Formatierung fr Zeitangaben
'----------------------------
Const FAendDat = "dd/mm/yy"						'Format fr das nderungsdatum (z.B. "dd/mm/yyyy hh:mm:ss")
Const FAufnDat = "dd/mm/yyyy hh:mm:ss"			'Format fr das nderungsdatum (z.B. "dd/mm/yy")

'berschriften
'=============
'Allgemeine Daten
'----------------
Const UebExt = "Ext."							'Dateityp (Extension)
Const UebGro = "Byte"							'Dateigre in Byte
Const UebAeD = "nd.Da."						'nderungsdatum (auch "nd.-Datum" mglich)

'Exif-Daten
'-----------
Const UebKam  = "Kamera"						'Kameratyp
Const UebAnD  = "Aufn.-Datum"					'Aufnahmedatum
Const UebGBH  = "BxH [Px]"						'Gre B x H in Pixel
Const UebGGP  = "Pixel"							'Gesamtgre in Pixel
Const UebBld  = "Bld"							'Blende
Const UebBZt  = "Zeit"							'Belichtungszeit
Const UebBKt  = "EV"							'Belichtungskorrektur
Const UebBrW  = "Brennweite"					'Brennweite
Const UebBli  = "Blitz"							'Blitz (Ein/Aus)
Const UebISO  = "ISO"							'Empfindlichkeit (ISO)
Const UebKom  = "Kommentar"						'Kommentar
Const UebGeo  = "Geodaten"						'Geodaten
Const UebBBS  = "Beschreibung"				'Bildbeschreibung

'IPTC-Daten
'----------
Const UebUeber  = "berschrift"					'berschrift
Const UebAutor	= "Autor"						'Autor
Const UebObjN   = "Objektname"					'Objektname
Const UebObjB   = "Obj.-Beschr."				'Obj.-Beschr.
Const UebKat    = "Kategorie"					'Kategorie
Const UebCop    = "Copyright"					'Copyright
Const UebFot    = "Fotograf"					'Fotograf
Const UebLand   = "Land"						'Land
Const UebReg    = "Region"						'Region
Const UebOrt    = "Ort"							'Ort
Const UebOTeil  = "Ortsteil"					'Ortsteil
Const UebSchlW  = "Schlagwrter"				'Schlagwrter

' ***********************************************************************

Const debugging = False
Const BugWatch = True

Dim n				'Zhlervariable
Dim m				'Zhlervariable
Dim objFolder	 	'Ordner
Dim objsubfolder	'Unterordner
Dim objExcel		'Excel-Objekt
Dim imagecount		'BildZhler
Dim objFile	 		'Dateien
Dim Dimension		'Tiefe des Datenarrys
Dim Gesamtanzahl	'Lnge des Datenarrays
Dim FileAnzahl	 	'Dateizhler
Dim SubAnzahl		'Ordnerzhler
Dim Tiefe			'Tiefe der Ordnerstruktur
Dim msg				'Message
Dim	DatGross		'Summe der Dateigren
Dim Array()			'Wertetabelle
Dim DateiGroesse	'Dateigre
Dim AeDatum			'nderungsdatum
Dim AuDatum			'Aufnahmedatum
Dim Zeile	 	 	'Zeile
Dim Spalte			'Spalte
Dim strExt	 		'Extension einer Datei
Dim Pfad			'Pfadangabe eines Ordners
Dim Anzahl			'Dateianzahl eines Ordners
Dim Kursivzeilen	'Zeilen mit Ordnernamen
Dim VonBisZeile		'von Kursivzeile zu Kursivzeile
Dim KursivListe		'Liste mit Ordnernamen
Dim Element			'Element der Kursivliste
Dim KameraModell	'Kamera-Modell aus Exif
Dim EndSpalte		'letzte Spalte

Dim ZusText			'Zusammenfassung
Dim Info1			'Info temporr eins
Dim Info2			'Info temporr zwei

Dim Kommentar		'Kommentar in den Exif-Daten
Dim KommentarElemente	'Kommentarteile
Dim BoolZeile		'true wenn mehrere Kommentarteile
Dim Wert			'Kommentarteil

Dim Pos				'StringPosition
Dim Antwort			'Antwort
Dim Abbruch			'Abbruch
Dim BFilter			'Bildfilter
Dim TabZeile		'Tabellenzeile
Dim BezZeile		'Bezeichnungszeile

Dim FortschrW		'Fortschrittwert
Dim FortschrG		'Fortschrittgrenze
Dim ProzLaden		'Prozentsatz des Ladevorgangs

Dim Breite			'Breite in Pixel
Dim Hoehe			'Hhe in Pixel

'Exif-Konstanten
Const Kamera = "Model"					'Kameraname (Exif)
Const AufnDatum	= "DateTimeOriginal" 	'Aufnahmedatum (Exif)
Const Blende = "FNumber"				'Blende
Const Zeit = "ExposureTime"				'Belichtungszeit
Const Korrektur = "ExposureBiasValue"	'Belichtungskorrektur
Const Brennweite = "FocalLength"		'Brennweite (OG + KB)
Const ISO = "ISOSpeedRatings"			'Empfindlichkeit
Const Blitz = "Flash"					'Blitz (codiert)
Const Beschreibung = "ImageDescription"	'Bildbeschreibung

'IPTC-Konstanten
'---------------
Const Headline = "Headline"				'berschrift
Const Autor = "Byline"					'Autor
Const Objekt = "ObjectName"				'Objektname
Const ObjektB = "Caption/Abstract"		'Obj.-Beschr.
Const Kategorie = "Category"			'Kategorie
Const Copyright = "CopyrightNotice"		'Copyright
Const Fotograf = "Writer/Editor"		'Fotograf
Const Land = "Country"					'Land
Const Region = "ProvinceState"			'Region
Const Ort = "City"						'Ort
Const Ortsteil  = "Sublocation"			'Ortsteil
Const Schlagworte = "Keywords"			'Schlagwrter

'Excel-Konstanten
Const xlRight = -4152	'Rechtsbndig
Const xlCenter = -4108	'Mittig
Const xlLeft = -4131	'Linksbndig

Const xlDiagonalDown = 5
Const xlNone = -4142
Const xlDiagonalUp = 6
Const xlEdgeLeft = 7
Const xlContinuous = 1
Const xlThin = 2
Const xlAutomatic = -4105
Const xlEdgeTop = 8
Const xlEdgeBottom = 9
Const xlEdgeRight = 10
Const xlInsideVertical = 11
Const xlInsideHorizontal = 12
Const xlPrintNoComments = -4142
Const xlPortrait = 1	'Hochformat
Const xlLandscape = 2	'Querformat
Const xlPaperA4 = 9
Const xlDownThenOver = 1
Const xlGeneral = 1
Const xlTop = -4160

Const xlAscending = 1
Const xlGuess = 0
Const xlTopToBottom = 1


dim Taste,SkriptKill,TempFile,NFilter,flagNFilter,flagThumbnail,Thn_langeSeite
dim DokuWert,Formatwert,Formwert,SeitenWert,Gitter,AllgWert,ExifWert,FilterWert
dim IPTCWert,IPTC(11),IPTCSp(11)
dim Doku(3),Form(1),Seit(3),Allg(2),Exif(12),AllgSp(2),ExifSp(12),Rand
dim BW_Org,BW_KB,Codepage,flag_GeoDez

const SkriptName = "ImageInfo_To_Excel.vbs"					'Skriptname
Dim Kurzbeschreibung, KBvorhanden, LaengeMax				'Kurzbeschreibung
const ForReading = 1, ForWriting = 2, ForAppending = 8

Dim objFS,WshShell,tOrdner									'Objekte und Temp-Ordner

Set objFS = CreateObject("Scripting.FileSystemObject")
tOrdner = objFS.GetSpecialFolder(2)			'Temp-Ordner

Set WshShell = CreateObject("WScript.Shell")

'Updatekonstanten und Variable
const SkriptVersion = "4.12"
const SkriptURL = "http://www.ffsf.de/resources/bilderinfo-nach-excel.142/"
Dim UrlVersion,UrlV_Zahl,SkriptV_Zahl,SkriptEnde

'******************* VB-Script **************************************
SetLocale("de-de")	'Lndercode "Deutsch - Deutschland"
call main
'--------------------------------------------------------------------
Sub main

	on error resume next									'Kontrolle ob Skript in FF-Umgebung gestartet wurde
		imagecount = FF_GetImageCount
 		if Err.Number = 500 then
			msgbox "Das Skript funktioniert nur in der Programmumgebung von FixFoto!",vbCritical,"Abbruch"
			exit sub
		end if
	on error goto 0
	
	Set objFolder = objFS.GetFolder(FF_GetImagePath())			'aktiver Ordner

	If objFolder Is Nothing Then								'kein Ordner bekannt 
		msgbox "Kein Ordner ausgewhlt." & vbNewline & "Die Dokumentation wird abgebrochen!",vbCritical,"Abbruch"
		exit sub
	end if

	Set objExcel = CreateObject("Excel.Application")			'Excel-Aufruf
	If objExcel Is Nothing then
	    msgbox "Excel kann nicht gestartet werden (evtl. nicht installiert)." & _
	    		vbNewline & "Die Dokumentation wird abgebrochen!",vbCritical,"Abbruch"
	    exit sub
	end if
		
'**  Dialogbehandlung ***********************************************
call Dialogaufruf
	'Registry lesen
	Formatwert = FF_GetProfile("FF_Doku-Excel", "Formatwert")	'erst ab Version 2.0 vorhanden
call WertBestimmung
call WerteEintrag
call Auswerten
call RegistrySchreiben

	FF_CloseDialog("Dateien-Doku")

if SkriptKill then		'ggf. Skript komplett entfernen
	call KillSkript
	exit sub
end if
	
'** Ende Dialogbehandlung ********************************************

if Abbruch then
	'msgbox "Das Skript wird abgebrochen!",vbCritical,"Abbruch"
	exit sub
end if

'** Abfrage ob Bilder ausgewhlt wurden
if Doku(0) = "1" then		'ausgewhlte Bilder
	imagecount = FF_GetImageCount
	if debugging then msgbox "Bilderzahl " & imagecount
	if imagecount = 0 then
		Antwort = msgbox("Es wurde kein(e) Bild(er) ausgewhlt." & vbCr & _
		"Es werden alle Bilder dokumentiert (ohne Uvz.).",vbOkCancel,"Abfrage")
		if Antwort = vbCancel then 
			Abbruch = True
		else
			Doku(0) = "0"	'ausgew.Bilder
			Doku(1) = "1"	'alle Bilder
		end if
	end if
end if

if Abbruch then
	msgbox "Das Skript wird abgebrochen!",vbCritical,"Abbruch"
	exit sub
end if

'** Codepage ermitteln
CodePa_Array = split(CodePauswahl,"/")
for n = 0 to ubound(CodePw_Array)
	if CodePw_Array(n) = CodeP_Wert then
		Codepage = CodePa_Array(n)
		exit for
	end if
next 
if Codepage = "Auto" then MappMerker = "Auto"

'** Arraygre bestimmen
call ArrayGroesse
Redim Array(Gesamtanzahl + 1, Dimension + 2)

'** Fortschrittsgren bestimmen
FortschrW = Gesamtanzahl/100*ProzWert
FortschrG = FortschrW
ProzLaden = ProzWert

if debugging then 
	msgbox "Dimension:	" & Dimension & vbNewLine & _
		   "Gesamtanzahl:	" & Gesamtanzahl
end if

'** Excelblatt aufrufen und Eintrag der Kopfzeilen
'Definitionen
Zeile = 6 	'Tabellenlistenbeginn

if Doku(0) = "1" then
	msg = "Ausgewhlte Bilder"
	if flagNFilter = 1 then msg = msg & ", gefiltert mit " & NFilter
elseif Doku(1) = "1" then
	msg = "Alle Bilder gefiltert mit " & BFilter
	if flagNFilter = 1 then msg = msg & " und mit " & NFilter
elseif Doku(2) = "1" then
	msg = "Alle Dateien"
	if flagNFilter = 1 then msg = msg & ", gefiltert mit " & NFilter
end if


if Doku(3) = "1" then msg = msg & " incl. Inhalt von Unterverzeichnissen"

With objExcel
	.Workbooks.Add
	.Visible = True
	.ActiveSheet.Cells(1,1).Value = objFolder.Path
	.ActiveSheet.Cells(3,1).Value = msg

' "Bitte warten!" eintragen
	.Range("C4").Select
	.Selection.Font.ColorIndex = 3
    With .Selection.Font
        .Name = "Arial"
        .Size = 18
    End With
    .ActiveSheet.Cells(4,3).Value = "Bitte warten!"
    .Range("A1").Select

call Ueberschrift

'** Array-Eintrag
TabZeile = 1
FileAnzahl = 0
if Doku(0) = "1" then										'ausgew. Bilder
	For m=0 to imagecount - 1
		set objFile = objFS.GetFile(FF_GetImageName(m))
		if flagNFilter = 0 or instr(objFile.Name,Nfilter) > 0 then
			TabZeile = TabZeile + 1
			call Tabellenerstellung
		end if
	Next
	
	TabZeile = TabZeile + 1
	call DateigroessenFormat
	Array(1,0) = objFolder.path & " < " & Fileanzahl &_
				" Dateien / " &	DatGross & " >"					'Ordnername
	Kursivzeilen = Kursivzeilen & cstr(Zeile + 1) & ":" & cstr(Zeile + 1) & ","
else
	ShowSubfolder ObjFolder,0
	call DateigroessenFormat
end if

	.ActiveSheet.Cells(2,1).Value = _				
		DatGross & " gesamt / " & SubAnzahl - 1 & " Unterordner / insgesamt " &_
		FormatNumber(FileAnzahl,0) & " Dateien"

'** Arraybertragung nach Excel

	.ActiveSheet.Cells(Zeile,2).Resize(Ubound(Array,1)+1,Ubound(Array,2)+1).Value = Array

'** Formatierung
	.ActiveSheet.Cells(4,3).Value = ""
call Formatierung

if Formatwert = "1" then
	' "Formatierung!" eintragen
	FF_Sleep(1000)
	.ActiveSheet.Cells(4,3).Value = "Formatierung - Bitte warten!"
	.Range("C" + cstr(4)).Select
	.Range("A1").Select
	
	call SeiteFormatieren

	FF_Sleep(1000)
	.Range("A4").Select
    .Selection.EntireRow.Delete
	
	if Gitter = "1" then
	
		if EndSpalte > 27 then
			.Range("B5:" & "A" & chr(37+EndSpalte) & Cstr(TabZeile+Zeile-2)).Select
		else
			.Range("B5:" & chr(63+EndSpalte) & Cstr(TabZeile+Zeile-2)).Select
		end if
		call ExcelGitter
	end if
else
	FF_Sleep(1000)
	.Range("A4").Select
    .Selection.EntireRow.Delete
end if
	
.Range("A1").Select
end with

if flagThumbnail = "1" then call ThumbnailEintrag

end sub
'********************************************************************
'Dialogbehandlung
'********************************************************************
sub Dialogaufruf()
'** Start Dialog Dateien-Doku **
FF_AddDialog "Dateien-Doku",240,264
FF_AddControl "Dateien-Doku","Codepage","GROUP",172,177,56,21
FF_AddControl "Dateien-Doku","Kommentar / Schlagwrter","GROUP",85,177,81,21
FF_AddControl "Dateien-Doku","IPTC","GROUP",160,44,68,131
FF_AddControl "Dateien-Doku","FixFoto - Dokumentation fr Excel","STATIC",77,0,92,10
FF_AddControl "Dateien-Doku","Einstellungen","GROUP",7,10,70,191
FF_AddControl "Dateien-Doku","Auswahl","GROUP",10,20,63,56
FF_AddControl "Dateien-Doku","ausgBld","BOOL",15,30,8,8
FF_SetControlStyle "Dateien-Doku","ausgBld",16384
FF_AddControl "Dateien-Doku","ausgew. Bilder","STATIC",30,29,38,10
FF_AddControl "Dateien-Doku","alleBld","BOOL",15,40,8,8
FF_SetControlStyle "Dateien-Doku","alleBld",16384
FF_AddControl "Dateien-Doku","alle Bilder","STATIC",30,39,38,10
FF_AddControl "Dateien-Doku","alleDat","BOOL",15,50,8,8
FF_SetControlStyle "Dateien-Doku","alleDat",16384
FF_AddControl "Dateien-Doku","alle Dateien","STATIC",30,49,38,10
FF_AddControl "Dateien-Doku"," ","GROUP",26,37,44,36
FF_AddControl "Dateien-Doku","mUV","BOOL",30,60,8,8
FF_AddControl "Dateien-Doku","mit Uvz.","STATIC",43,59,21,10
FF_AddControl "Dateien-Doku","Blattformat","GROUP",10,79,63,119
FF_AddControl "Dateien-Doku","BlattF","BOOL",59,78,8,9
FF_AddControl "Dateien-Doku","HForm","BOOL",15,91,8,8
FF_SetControlStyle "Dateien-Doku","HForm",16384
FF_AddControl "Dateien-Doku","Hochformat","STATIC",30,90,38,10
FF_AddControl "Dateien-Doku","QForm","BOOL",15,101,8,8
FF_SetControlStyle "Dateien-Doku","QForm",16384
FF_AddControl "Dateien-Doku","Querformat","STATIC",30,100,38,10
FF_AddControl "Dateien-Doku","Seitenrnder:","STATIC",15,114,38,10
FF_AddControl "Dateien-Doku","oben","STATIC",15,127,20,10
FF_AddControl "Dateien-Doku","Roben","COMBO",40,127,25,10
FF_AddControl "Dateien-Doku","unten","STATIC",15,138,20,10
FF_AddControl "Dateien-Doku","Runten","COMBO",40,138,25,10
FF_AddControl "Dateien-Doku","links","STATIC",15,149,20,10
FF_AddControl "Dateien-Doku","Rlinks","COMBO",40,149,25,10
FF_AddControl "Dateien-Doku","rechts","STATIC",15,160,20,10
FF_AddControl "Dateien-Doku","Rrechts","COMBO",40,160,25,10
FF_AddControl "Dateien-Doku","EGitt","BOOL",15,178,8,8
FF_AddControl "Dateien-Doku","Gitter","STATIC",30,177,38,10
FF_AddControl "Dateien-Doku","Daten","GROUP",82,11,150,191
FF_AddControl "Dateien-Doku","Allgemein","GROUP",85,20,143,21
FF_AddControl "Dateien-Doku","DTyp","BOOL",90,30,8,8
FF_AddControl "Dateien-Doku","Dateityp","STATIC",101,29,24,10
FF_AddControl "Dateien-Doku","DGro","BOOL",127,30,8,8
FF_AddControl "Dateien-Doku","Dateigre","STATIC",140,29,30,10
FF_AddControl "Dateien-Doku","DAeD","BOOL",172,30,8,8
FF_AddControl "Dateien-Doku","nderungsdatum","STATIC",183,29,42,10
FF_AddControl "Dateien-Doku","Exif","GROUP",85,44,73,131
FF_AddControl "Dateien-Doku","EKam","BOOL",90,54,8,8
FF_AddControl "Dateien-Doku","Kameratyp","STATIC",105,53,47,10
FF_AddControl "Dateien-Doku","EAuD","BOOL",90,63,8,8
FF_AddControl "Dateien-Doku","Aufnahmedatum","STATIC",105,62,47,10
FF_AddControl "Dateien-Doku","EGrP","BOOL",90,72,8,8
FF_AddControl "Dateien-Doku","Gre (Pixel)","STATIC",105,71,47,10
FF_AddControl "Dateien-Doku","EBld","BOOL",90,81,9,8
FF_AddControl "Dateien-Doku","Blende","STATIC",105,80,47,10
FF_AddControl "Dateien-Doku","EBeZ","BOOL",90,90,8,8
FF_AddControl "Dateien-Doku","Belichtungszeit","STATIC",105,89,47,10
FF_AddControl "Dateien-Doku","EKorr","BOOL",90,99,8,8
FF_AddControl "Dateien-Doku","Bel.-Korrektur (EV)","STATIC",105,98,47,10
FF_AddControl "Dateien-Doku","EBrw","BOOL",90,109,8,8
FF_SetControlStyle "Dateien-Doku","EBrw",16384
FF_AddControl "Dateien-Doku","Brennweite","STATIC",105,107,47,10
FF_AddControl "Dateien-Doku","BW_Org","BOOL",99,118,8,8
FF_SetControlStyle "Dateien-Doku","BW_Org",16384
FF_AddControl "Dateien-Doku","Original","STATIC",108,117,20,10
FF_AddControl "Dateien-Doku","BW_KB","BOOL",128,118,8,8
FF_SetControlStyle "Dateien-Doku","BW_KB",16384
FF_AddControl "Dateien-Doku","Kleinb.","STATIC",138,117,17,10
FF_AddControl "Dateien-Doku","EBlz","BOOL",90,127,8,8
FF_AddControl "Dateien-Doku","Blitz (Ein/Aus)","STATIC",105,126,47,10
FF_AddControl "Dateien-Doku","EISO","BOOL",90,136,8,8
FF_AddControl "Dateien-Doku","Empfindl. (ISO)","STATIC",105,135,47,10
FF_AddControl "Dateien-Doku","EGeo","BOOL",90,154,8,8
FF_AddControl "Dateien-Doku","Geodaten","STATIC",105,153,47,10
FF_AddControl "Dateien-Doku","EKomm","BOOL",90,145,8,8
FF_AddControl "Dateien-Doku","Kommentar","STATIC",105,144,47,10
FF_AddControl "Dateien-Doku","KommEinz","BOOL",90,187,8,8
FF_SetControlStyle "Dateien-Doku","KommEinz",16384
FF_AddControl "Dateien-Doku","einzeilig","STATIC",104,186,20,10
FF_AddControl "Dateien-Doku","KommMehrz","BOOL",128,187,8,8
FF_SetControlStyle "Dateien-Doku","KommMehrz",16384
FF_AddControl "Dateien-Doku","mehrzeilig","STATIC",140,186,25,10
FF_AddControl "Dateien-Doku","Filterungen","GROUP",7,203,225,24
FF_AddControl "Dateien-Doku","Bildfilter","STATIC",15,211,34,10
FF_AddControl "Dateien-Doku","Filter","SLEDIT",36,211,80,10
FF_SetControlStyle "Dateien-Doku","Filter",1
FF_AddControl "Dateien-Doku","S","BUTTON",117,211,10,10
FF_AddControl "Dateien-Doku","Namensfilter","STATIC",138,211,34,10
FF_AddControl "Dateien-Doku","NFilter","SLEDIT",171,211,45,10
FF_SetControlStyle "Dateien-Doku","NFilter",1
FF_AddControl "Dateien-Doku","flagNFilter","BOOL",218,212,8,8
FF_AddControl "Dateien-Doku","flagThumbnail","BOOL",25,230,8,8
FF_AddControl "Dateien-Doku","Thumbnaileintrag als Kommentar mit lngster Seite von","STATIC",38,229,136,10
FF_AddControl "Dateien-Doku","?","BUTTON",17,246,12,11
FF_AddControl "Dateien-Doku","Alle Daten","BUTTON",134,246,38,11
FF_AddControl "Dateien-Doku","OK","BUTTON",188,246,38,11
FF_AddControl "Dateien-Doku","&d","BUTTON",2,253,1,1
FF_AddControl "Dateien-Doku","EBeschr","BOOL",90,163,8,8
FF_AddControl "Dateien-Doku","Beschreibung","STATIC",105,162,47,10
FF_AddControl "Dateien-Doku","IUeber","BOOL",165,54,8,8
FF_AddControl "Dateien-Doku","berschrift","STATIC",176,53,47,10
FF_AddControl "Dateien-Doku","IAutor","BOOL",165,63,8,8
FF_AddControl "Dateien-Doku","Autor","STATIC",176,62,47,10
FF_AddControl "Dateien-Doku","IObjN","BOOL",165,72,8,8
FF_AddControl "Dateien-Doku","Objektname","STATIC",176,71,47,10
FF_AddControl "Dateien-Doku","IObjB","BOOL",165,81,8,8
FF_AddControl "Dateien-Doku","Obj.-Beschr.","STATIC",176,80,47,10
FF_AddControl "Dateien-Doku","IKat","BOOL",165,90,8,8
FF_AddControl "Dateien-Doku","Kategorie","STATIC",176,89,47,10
FF_AddControl "Dateien-Doku","ICop","BOOL",165,99,8,8
FF_AddControl "Dateien-Doku","Copyright","STATIC",176,98,47,10
FF_AddControl "Dateien-Doku","IFot","BOOL",165,109,8,8
FF_AddControl "Dateien-Doku","Fotograf","STATIC",176,108,47,10
FF_AddControl "Dateien-Doku","ILand","BOOL",165,118,8,8
FF_AddControl "Dateien-Doku","Land","STATIC",176,117,47,10
FF_AddControl "Dateien-Doku","IReg","BOOL",165,127,8,8
FF_AddControl "Dateien-Doku","Region","STATIC",176,126,47,10
FF_AddControl "Dateien-Doku","IOrt","BOOL",165,136,8,8
FF_AddControl "Dateien-Doku","Ort","STATIC",176,134,47,10
FF_AddControl "Dateien-Doku","IOTeil","BOOL",165,145,8,8
FF_AddControl "Dateien-Doku","Ortsteil","STATIC",176,144,47,10
FF_AddControl "Dateien-Doku","ISchlW","BOOL",165,154,8,8
FF_AddControl "Dateien-Doku","Schlagwrter","STATIC",176,153,47,10
FF_AddControl "Dateien-Doku","Thn_langeSeite","SLEDIT",176,229,22,10
FF_SetControlStyle "Dateien-Doku","Thn_langeSeite",8193
FF_AddControl "Dateien-Doku","px","STATIC",200,229,10,10
FF_AddControl "Dateien-Doku","|","STATIC",34,246,26,11
FF_SetControlStyle "Dateien-Doku","|",1
FF_AddControl "Dateien-Doku","Update","BUTTON",65,246,33,11
FF_AddControl "Dateien-Doku","flag_GeoDez","BOOL",134,154,8,8
FF_AddControl "Dateien-Doku","dez.","STATIC",144,153,12,10
FF_AddControl "Dateien-Doku","CodeP_Wert","COMBO",176,185,48,10
FF_AddControl "Dateien-Doku","E_0_1","BOOL",145,43,8,8
FF_SetControlStyle "Dateien-Doku","E_0_1",20480
FF_AddControl "Dateien-Doku","I_0_1","BOOL",215,43,8,8
FF_SetControlStyle "Dateien-Doku","I_0_1",20480
'** End Dialog Dateien-Doku **

'** Vorbelegung der Codepage-Werte **
CodePw_Array = split(CodePwerte,"/")
for each CodePelement in CodePw_Array
	FF_SetControl "Dateien-Doku","CodeP_Wert",CodePelement
next

'** Vorbelegung des Auswahldialogs **
'mgliche Seitenrnder definieren
FF_SetControl "Dateien-Doku","Roben","0,5"
FF_SetControl "Dateien-Doku","Roben","1,0"
FF_SetControl "Dateien-Doku","Roben","1,5"
FF_SetControl "Dateien-Doku","Roben","2,0"
FF_SetControl "Dateien-Doku","Roben","2,5"

FF_SetControl "Dateien-Doku","Runten","1,0"
FF_SetControl "Dateien-Doku","Runten","1,5"
FF_SetControl "Dateien-Doku","Runten","2,0"
FF_SetControl "Dateien-Doku","Runten","2,5"

FF_SetControl "Dateien-Doku","Rlinks","0,5"
FF_SetControl "Dateien-Doku","Rlinks","1,0"
FF_SetControl "Dateien-Doku","Rlinks","1,5"
FF_SetControl "Dateien-Doku","Rlinks","2,0"

FF_SetControl "Dateien-Doku","Rrechts","0,5"
FF_SetControl "Dateien-Doku","Rrechts","1,0"
FF_SetControl "Dateien-Doku","Rrechts","1,5"
FF_SetControl "Dateien-Doku","Rrechts","2,0"

'Tooltips
if Version_OK("3.30.06") then
	FF_SetControlTooltip "Dateien-Doku","?", "" &_
						 "Anzeige der Kurzbeschreibung als PDF-Datei," & vbNewLine & _
						 "vorausgesetzt es ist ein PDF-Reader installiert." & vbNewLine & _
						 "Anderenfalls wird eine gekrzte Textversion angezeigt."
	FF_SetControlTooltip "Dateien-Doku","Update", "" &_
						 "Prfung ob eine neue Version vorliegt"
	FF_SetControlTooltip "Dateien-Doku","Alle Daten", "" &_
						 "Alle Daten werden markiert"
	FF_SetControlTooltip "Dateien-Doku","OK", "" &_
						 "Skriptstart"
end if

end sub
'********************************************************************
Sub WertBestimmung
'Auswahlwerte
if FF_GetProfile("FF_Doku-Excel", "Version") <> ">=3.04" then 
	DokuWert = "0/1/0/0"
	Formatwert = "1"
	Formwert = "0/1"
	SeitenWert = "2,0/1,5/1,0/1,0"
	Gitter = "1"
	AllgWert = "1/1/1"
	ExifWert = "1/1/1/1/1/1/1/1/1/1/1/1/1"
	IPTCWert = "1/1/1/1/1/1/1/1/1/1/1/1/1"
	BFilter = BildKenn
	BW_Org = "1"
	BW_KB = "1"
	flag_GeoDez = "1"
	CodeP_Wert = "Auto"
else
	DokuWert = FF_GetProfile("FF_Doku-Excel", "DokuWert")
	Formwert = FF_GetProfile("FF_Doku-Excel", "Formwert")
	SeitenWert = FF_GetProfile("FF_Doku-Excel", "SeitenWert")
	Gitter = FF_GetProfile("FF_Doku-Excel", "Gitter")
	AllgWert = FF_GetProfile("FF_Doku-Excel", "AllgWert")
	ExifWert = FF_GetProfile("FF_Doku-Excel", "ExifWert")
		if len(ExifWert) < 25 then ExifWert = ExifWert & "/1"
	IPTCWert = FF_GetProfile("FF_Doku-Excel", "IPTCWert")
		if len(IPTCWert) < 1 then IPTCWert = "1/1/1/1/1/1/1/1/1/1/1/1/1"
	BFilter = FF_GetProfile("FF_Doku-Excel", "FilterWert")
	BW_Org = FF_GetProfile("FF_Doku-Excel", "BW_Org")
	BW_KB = FF_GetProfile("FF_Doku-Excel", "BW_KB")
	flag_GeoDez = FF_GetProfile("FF_Doku-Excel", "flag_GeoDez")
	CodeP_Wert = FF_GetProfile("FF_Doku-Excel", "CodeP_Wert")
		if len(CodeP_Wert) < 1 then CodeP_Wert = "Auto"
end if

NFilter = FF_GetProfile("FF_Doku-Excel", "NFilterWert")
flagNFilter = FF_GetProfile("FF_Doku-Excel", "flagNFilter")

flagThumbnail = FF_GetProfile("FF_Doku-Excel", "flagThumbnail")
if flagThumbnail = "" then flagThumbnail = "0"
Thn_langeSeite = FF_GetProfile("FF_Doku-Excel", "Thn_langeSeite")
if Thn_langeSeite = "" then Thn_langeSeite = 100

end sub
'********************************************************************
sub WerteEintrag()
if not BugWatch then on error resume next
'Werte eintragen

'Codepage
FF_SetControl "Dateien-Doku","CodeP_Wert",CodeP_Wert

DokuWert = split(DokuWert,"/",-1)
FF_SetControl "Dateien-Doku","ausgBld",DokuWert(0)
FF_SetControl "Dateien-Doku","alleBld",DokuWert(1)
FF_SetControl "Dateien-Doku","alleDat",DokuWert(2)
FF_SetControl "Dateien-Doku","mUV",DokuWert(3)

FF_SetControl "Dateien-Doku","BlattF",Formatwert

FormWert = split(FormWert,"/",-1)
FF_SetControl "Dateien-Doku","HForm",FormWert(0)
FF_SetControl "Dateien-Doku","QForm",FormWert(1)

SeitenWert = split(SeitenWert,"/",-1)
FF_SetControl "Dateien-Doku","Roben",SeitenWert(0)
FF_SetControl "Dateien-Doku","Runten",SeitenWert(1)
FF_SetControl "Dateien-Doku","Rlinks",SeitenWert(2)
FF_SetControl "Dateien-Doku","Rrechts",SeitenWert(3)

FF_SetControl "Dateien-Doku","EGitt",Gitter

AllgWert = split(AllgWert,"/",-1)
FF_SetControl "Dateien-Doku","DTyp",AllgWert(0)
FF_SetControl "Dateien-Doku","DGro",AllgWert(1)
FF_SetControl "Dateien-Doku","DAeD",AllgWert(2)

ExifWert = split(ExifWert,"/",-1)
FF_SetControl "Dateien-Doku","EKam",ExifWert(0)
FF_SetControl "Dateien-Doku","EAuD",ExifWert(1)
FF_SetControl "Dateien-Doku","EGrP",ExifWert(2)
FF_SetControl "Dateien-Doku","EBld",ExifWert(3)
FF_SetControl "Dateien-Doku","EBeZ",ExifWert(4)
FF_SetControl "Dateien-Doku","EKorr",ExifWert(5)
FF_SetControl "Dateien-Doku","EBrw",ExifWert(6)
FF_SetControl "Dateien-Doku","EBlz",ExifWert(7)
FF_SetControl "Dateien-Doku","EISO",ExifWert(8)
FF_SetControl "Dateien-Doku","EKomm",ExifWert(9)
if ExifWert(10) = "1" then
	FF_SetControl "Dateien-Doku","KommEinz","1"
else
	FF_SetControl "Dateien-Doku","KommMehrz","1"
end if
FF_SetControl "Dateien-Doku","EGeo",ExifWert(11)
FF_SetControl "Dateien-Doku","EBeschr",ExifWert(12)

IPTCWert = split(IPTCWert,"/",-1)
FF_SetControl "Dateien-Doku","IUeber",IPTCWert(0)
FF_SetControl "Dateien-Doku","IAutor",IPTCWert(1)
FF_SetControl "Dateien-Doku","IObjN",IPTCWert(2)
FF_SetControl "Dateien-Doku","IObjB",IPTCWert(3)
FF_SetControl "Dateien-Doku","IKat",IPTCWert(4)
FF_SetControl "Dateien-Doku","ICop",IPTCWert(5)
FF_SetControl "Dateien-Doku","IFot",IPTCWert(6)
FF_SetControl "Dateien-Doku","ILand",IPTCWert(7)
FF_SetControl "Dateien-Doku","IReg",IPTCWert(8)
FF_SetControl "Dateien-Doku","IOrt",IPTCWert(9)
FF_SetControl "Dateien-Doku","IOTeil",IPTCWert(10)
FF_SetControl "Dateien-Doku","ISchlW",IPTCWert(11)

FF_SetControl "Dateien-Doku","BW_Org",BW_Org
FF_SetControl "Dateien-Doku","BW_KB",BW_KB
FF_SetControl "Dateien-Doku","flag_GeoDez",flag_GeoDez
FF_SetControl "Dateien-Doku","Filter",BFilter
FF_SetControl "Dateien-Doku","NFilter",NFilter
FF_SetControl "Dateien-Doku","flagNFilter",flagNFilter
FF_SetControl "Dateien-Doku","flagThumbnail",flagThumbnail
FF_SetControl "Dateien-Doku","Thn_langeSeite",Thn_langeSeite

end sub
'********************************************************************
sub Auswerten()
'Auswahl anzeigen und auswerten
Dim Anzeige

FF_ActivateControl "Dateien-Doku","&d"
FF_SetDialogTimer "Dateien-Doku", 100

do
	Taste = FF_ShowDialog("Dateien-Doku")
	if Taste =  "&d" then
		Abbruch = false
		SkriptKill = false
		Antwort = msgbox("Soll das Skript " & SkriptName & vbNewline & _
						 "mit allen dazugehrigen Komponenten wirklich gelscht werden?", _
						 vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			SkriptKill = true
			exit do
		end if
	elseif Taste = "TIMER" then
		FF_SetControl "Dateien-Doku" ,"|", "V " & Skriptversion
		FF_SetDialogTimer "Dateien-Doku", 0
	elseif Taste = "Update" then
		SkriptEnde = false
		call Update
		if SkriptEnde then exit do
	elseif Taste = "E_0_1" then
		if FF_GetControl("Dateien-Doku","E_0_1") = "0" then
			for each EI_Date in EDat_Array
				FF_SetControl "Dateien-Doku",EI_Date,"1"
			next
		else
			for each EI_Date in EDat_Array
				FF_SetControl "Dateien-Doku",EI_Date,"0"
			next
		end if
	elseif Taste = "I_0_1" then
		if FF_GetControl("Dateien-Doku","I_0_1") = "0" then
			for each EI_Date in IDat_Array
				FF_SetControl "Dateien-Doku",EI_Date,"1"
			next
		else
			for each EI_Date in IDat_Array
				FF_SetControl "Dateien-Doku",EI_Date,"0"
			next
		end if	
	elseif Taste = "ausgBld" then 
		FF_SetControl "Dateien-Doku","ausgBld","1"
		FF_SetControl "Dateien-Doku","alleBld","0"
		FF_SetControl "Dateien-Doku","alleDat","0"
		FF_SetControl "Dateien-Doku","mUV","0"
	elseif Taste = "alleBld" then
		FF_SetControl "Dateien-Doku","ausgBld","0"
		FF_SetControl "Dateien-Doku","alleBld","1"
		FF_SetControl "Dateien-Doku","alleDat","0"
	elseif Taste = "alleDat" then
		FF_SetControl "Dateien-Doku","ausgBld","0"
		FF_SetControl "Dateien-Doku","alleBld","0"
		FF_SetControl "Dateien-Doku","alleDat","1"
	elseif Taste = "BW_Org" then
		FF_SetControl "Dateien-Doku","EBrw","1"
		if FF_GetControl ("Dateien-Doku","BW_KB") = "0" then
			FF_SetControl "Dateien-Doku","BW_Org","1"
		end if
	elseif Taste = "BW_KB" then
		FF_SetControl "Dateien-Doku","EBrw","1"
		if FF_GetControl ("Dateien-Doku","BW_Org") = "0" then
			FF_SetControl "Dateien-Doku","BW_KB","1"
		end if
	elseif Taste = "KommEinz" then
		FF_SetControl "Dateien-Doku","KommEinz","1"
		FF_SetControl "Dateien-Doku","KommMehrz","0"
	elseif Taste = "KommMehrz" then
		FF_SetControl "Dateien-Doku","KommEinz","0"
		FF_SetControl "Dateien-Doku","KommMehrz","1"	
	elseif Taste = "S" then
		BFilter = FF_GetControl("Dateien-Doku","Filter")
		if BFilter <> BildKenn then
		Antwort = msgbox("Soll der Bildfilter wieder seinen Standard " & vbNewLine & _
						 Bildkenn & " erhalten?",vbYesNo,"Abfrage")
		if Antwort = vbYes then
			BFilter = BildKenn
			FF_SetControl "Dateien-Doku","Filter",BFilter
		end if
		end if
	end if

	if Taste = "HForm" then 
		FF_SetControl "Dateien-Doku","HForm","1"
		FF_SetControl "Dateien-Doku","QForm","0"
	elseif Taste = "QForm" then
		FF_SetControl "Dateien-Doku","HForm","0"
		FF_SetControl "Dateien-Doku","QForm","1"
	end if
	
	if Taste = "?" then
		Anzeige = """" & FF_GetScriptPath & "\MeckiScript\ImageInfo_To_Excel\Bilderinfo_nach_Excel.pdf" & """"
		on error resume next
		WshShell.Run Anzeige,1,false
		if err <> 0 then
			msgbox "Die Kurzbeschreibung konnte nicht als PDF-Datei geffnet werden." & vbNewLine & _
				   "Die Datei ist gelscht oder es ist kein PDF-Reader installiert (?)." & vbNewLine & vbNewLine &_
				   "Ersatzweise erfolgt eine Textanzeige!",vbExclamation,"Hinweis"
			err.clear
			
			if not KBvorhanden then	call KurzbeschreibungLesen
			if KBvorhanden then
				call KurzbeschreibungAnzeigen
			else
				msgbox "Keine Kurzbeschreibung gefunden!",vbExclamation,"Meldung"
			end if
			
		end if
		on error GoTo 0
		
	elseif Taste = "OK" then
		flagThumbnail = FF_GetControl("Dateien-Doku","flagThumbnail")
		Thn_langeSeite = FF_GetControl("Dateien-Doku","Thn_langeSeite") *1
 		if flagThumbnail = "0" or Thn_langeSeite > 99 and Thn_langeSeite < 401 then
			exit do
		else
			msgbox "Fr den Thumbnaileintrag muss die Gre" & vbNewLine & _
				   "der lngsten Seite mindestens 100 px und" & vbNewLine & _
				   "hchstens 400 px betragen!",vbExclamation,"Hinweis"
		end if
	elseif Taste = "CANCEL" then
		Abbruch = True
		exit do
	elseif Taste = "Alle Daten" then
		AllgWert = "1/1/1"
		ExifWert = "1/1/1/1/1/1/1/1/1/1/1/1"
		IPTCWert = "1/1/1/1/1/1/1/1/1/1/1/1"
		
AllgWert = split(AllgWert,"/",-1)
FF_SetControl "Dateien-Doku","DTyp",AllgWert(0)
FF_SetControl "Dateien-Doku","DGro",AllgWert(1)
FF_SetControl "Dateien-Doku","DAeD",AllgWert(2)

ExifWert = split(ExifWert,"/",-1)
FF_SetControl "Dateien-Doku","EKam",ExifWert(0)
FF_SetControl "Dateien-Doku","EAuD",ExifWert(1)
FF_SetControl "Dateien-Doku","EGrP",ExifWert(2)
FF_SetControl "Dateien-Doku","EBld",ExifWert(3)
FF_SetControl "Dateien-Doku","EBeZ",ExifWert(4)
FF_SetControl "Dateien-Doku","EKorr",ExifWert(5)
FF_SetControl "Dateien-Doku","EBrw",ExifWert(6)
FF_SetControl "Dateien-Doku","EBlz",ExifWert(7)
FF_SetControl "Dateien-Doku","EISO",ExifWert(8)
FF_SetControl "Dateien-Doku","EKomm",ExifWert(9)
FF_SetControl "Dateien-Doku","EGeo",ExifWert(10)
FF_SetControl "Dateien-Doku","EBeschr",ExifWert(11)

IPTCWert = split(IPTCWert,"/",-1)
FF_SetControl "Dateien-Doku","IUeber",IPTCWert(0)
FF_SetControl "Dateien-Doku","IAutor",IPTCWert(1)
FF_SetControl "Dateien-Doku","IObjN",IPTCWert(2)
FF_SetControl "Dateien-Doku","IObjB",IPTCWert(3)
FF_SetControl "Dateien-Doku","IKat",IPTCWert(4)
FF_SetControl "Dateien-Doku","ICop",IPTCWert(5)
FF_SetControl "Dateien-Doku","IFot",IPTCWert(6)
FF_SetControl "Dateien-Doku","ILand",IPTCWert(7)
FF_SetControl "Dateien-Doku","IReg",IPTCWert(8)
FF_SetControl "Dateien-Doku","IOrt",IPTCWert(9)
FF_SetControl "Dateien-Doku","IOTeil",IPTCWert(10)
FF_SetControl "Dateien-Doku","ISchlW",IPTCWert(11)
	end if
loop
end sub
'********************************************************************
sub RegistrySchreiben
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\FF_Doku-Excel

'Codepage
CodeP_Wert = FF_GetControl("Dateien-Doku","CodeP_Wert")
FF_WriteProfile "FF_Doku-Excel","CodeP_Wert",CodeP_Wert

'Auswahl in Registry sichern
Doku(0) = FF_GetControl("Dateien-Doku","ausgBld")
Doku(1) = FF_GetControl("Dateien-Doku","alleBld")
Doku(2) = FF_GetControl("Dateien-Doku","alleDat")
Doku(3) = FF_GetControl("Dateien-Doku","mUV")
FF_WriteProfile "FF_Doku-Excel","DokuWert",Doku(0) & "/" & Doku(1) & _
									 "/" & Doku(2) & "/" & Doku(3)

Formatwert = FF_GetControl("Dateien-Doku","BlattF")
FF_WriteProfile "FF_Doku-Excel","Formatwert",Formatwert

Form(0) = FF_GetControl("Dateien-Doku","HForm")
Form(1) = FF_GetControl("Dateien-Doku","QForm")
FF_WriteProfile "FF_Doku-Excel","FormWert",Form(0) & "/" & Form(1)

Seit(0) = FF_GetControl("Dateien-Doku","Roben")
Seit(1) = FF_GetControl("Dateien-Doku","Runten")
Seit(2) = FF_GetControl("Dateien-Doku","Rlinks")
Seit(3) = FF_GetControl("Dateien-Doku","Rrechts")
FF_WriteProfile "FF_Doku-Excel","SeitenWert",Seit(0) & "/" & Seit(1) & _
									   "/" & Seit(2) & "/" & Seit(3)

Gitter = FF_GetControl("Dateien-Doku","EGitt")
FF_WriteProfile "FF_Doku-Excel","Gitter",Gitter

Allg(0) = FF_GetControl("Dateien-Doku","DTyp")
Allg(1) = FF_GetControl("Dateien-Doku","DGro")
Allg(2) = FF_GetControl("Dateien-Doku","DAeD")
FF_WriteProfile "FF_Doku-Excel","AllgWert",Allg(0) & "/" & Allg(1) & _
													 "/" & Allg(2)

Exif(0) = FF_GetControl("Dateien-Doku","EKam")
Exif(1) = FF_GetControl("Dateien-Doku","EAuD")
Exif(2) = FF_GetControl("Dateien-Doku","EGrP")
Exif(3) = FF_GetControl("Dateien-Doku","EBld")
Exif(4) = FF_GetControl("Dateien-Doku","EBeZ")
Exif(5) = FF_GetControl("Dateien-Doku","EKorr")
Exif(6) = FF_GetControl("Dateien-Doku","EBrw")
Exif(7) = FF_GetControl("Dateien-Doku","EBlz")
Exif(8) = FF_GetControl("Dateien-Doku","EISO")
Exif(9) = FF_GetControl("Dateien-Doku","EKomm")
Exif(10) = FF_GetControl("Dateien-Doku","KommEinz")
Exif(11) = FF_GetControl("Dateien-Doku","EGeo")
Exif(12) = FF_GetControl("Dateien-Doku","EBeschr")
FF_WriteProfile "FF_Doku-Excel","ExifWert",Exif(0) & "/" & Exif(1) & "/" & Exif(2) & "/" & Exif(3) & _
					 "/" & Exif(4) & "/" & Exif(5) & "/" & Exif(6) & "/" & Exif(7) & "/" & Exif(8) & _
					 "/" & Exif(9) & "/" & Exif(10) & "/" & Exif(11) & "/" & Exif(12)

IPTC(0) = FF_GetControl("Dateien-Doku","IUeber")
IPTC(1) = FF_GetControl("Dateien-Doku","IAutor")
IPTC(2) = FF_GetControl("Dateien-Doku","IObjN")
IPTC(3) = FF_GetControl("Dateien-Doku","IObjB")
IPTC(4) = FF_GetControl("Dateien-Doku","IKat")
IPTC(5) = FF_GetControl("Dateien-Doku","ICop")
IPTC(6) = FF_GetControl("Dateien-Doku","IFot")
IPTC(7) = FF_GetControl("Dateien-Doku","ILand")
IPTC(8) = FF_GetControl("Dateien-Doku","IReg")
IPTC(9) = FF_GetControl("Dateien-Doku","IOrt")
IPTC(10) = FF_GetControl("Dateien-Doku","IOTeil")
IPTC(11) = FF_GetControl("Dateien-Doku","ISchlW")
FF_WriteProfile "FF_Doku-Excel","IPTCWert",IPTC(0) & "/" & IPTC(1) & "/" & IPTC(2) & "/" & IPTC(3) & _
					 "/" & IPTC(4) & "/" & IPTC(5) & "/" & IPTC(6) & "/" & IPTC(7) & "/" & IPTC(8) & _
					 "/" & IPTC(9) & "/" & IPTC(10) & "/" & IPTC(11)

flag_GeoDez = FF_GetControl("Dateien-Doku","flag_GeoDez")
FF_WriteProfile "FF_Doku-Excel","flag_GeoDez",flag_GeoDez
BW_Org = FF_GetControl("Dateien-Doku","BW_Org")
FF_WriteProfile "FF_Doku-Excel","BW_Org",BW_Org
BW_KB = FF_GetControl("Dateien-Doku","BW_KB")
FF_WriteProfile "FF_Doku-Excel","BW_KB",BW_KB

BFilter = FF_GetControl("Dateien-Doku","Filter")
FF_WriteProfile "FF_Doku-Excel","FilterWert",BFilter

NFilter = FF_GetControl("Dateien-Doku","NFilter")
FF_WriteProfile "FF_Doku-Excel","NFilterWert",NFilter
flagNFilter = FF_GetControl("Dateien-Doku","flagNFilter")
FF_WriteProfile "FF_Doku-Excel","flagNFilter",flagNFilter

flagThumbnail = FF_GetControl("Dateien-Doku","flagThumbnail")
FF_WriteProfile "FF_Doku-Excel","flagThumbnail",flagThumbnail

Thn_langeSeite = FF_GetControl("Dateien-Doku","Thn_langeSeite")
FF_WriteProfile "FF_Doku-Excel","Thn_langeSeite",Thn_langeSeite

FF_WriteProfile "FF_Doku-Excel","Version",">=3.04"
end sub
'********************************************************************
Sub ArrayGroesse
'Ermittlung der Dimension
For n = 0 to 2
	if Allg(n) = "1" then Dimension = Dimension + 1
next

For n = 0 to 12
	if Exif(n) = "1" then Dimension = Dimension + 1
next
if Exif(2) = "1" then Dimension = Dimension + 1	'Bildgre BxH und Pixel

For n = 0 to 11
	if IPTC(n) = "1" then Dimension = Dimension + 1
next

'Ermittlung der Gesamtanzahl (Ordner und Dateien)
if Doku(0) = "1" then 
	Gesamtanzahl = imagecount
		SubAnzahl = 1
		FileAnzahl = imagecount
elseif Doku(3) = "1" then
	ZaehlerSub (objFolder)
	Gesamtanzahl = SubAnzahl - 1 + FileAnzahl
elseif Doku(1) = "1" or Doku(2) = "1" then
	Gesamtanzahl = objFolder.files.count
		SubAnzahl = 1
else
	msgbox "Keine Doku ausgewhlt -> Abbruch"
	FF_ErrorBreak "Abbruch"
end if
end sub
'********************************************************************
Sub ZaehlerSub(ByVal myfolder)
'Zhlen der Ordner, Unterordner und Dateien

SubAnzahl = SubAnzahl + 1						'Anzahl Unterordner
FileAnzahl = FileAnzahl + myfolder.files.count	'Anzahl Dateien

For Each objsubfolder In myfolder.subfolders
     ZaehlerSub (objsubfolder)
Next

end sub
'********************************************************************
Sub Ueberschrift
'berschrift ins Array eintragen
n = 0
Array(0,0) = "ON" : n = n + 1
Array(0,1) = "Dateiname" : n = n + 1

'Allgemeine Daten
if Allg(0) = "1" then Array(0,n) = UebExt : AllgSp(0) = n : n = n + 1
if Allg(1) = "1" then Array(0,n) = UebGro : AllgSp(1) = n : n = n + 1
if Allg(2) = "1" then Array(0,n) = UebAeD : AllgSp(2) = n : n = n + 1

'Exif-Daten
if Exif(0) = "1" then Array(0,n) = UebKam : ExifSp(0) = n : n = n + 1
if Exif(1) = "1" then Array(0,n) = UebAnD : ExifSp(1) = n : n = n + 1
if Exif(2) = "1" then 
					  Array(0,n) = UebGBH : ExifSp(2) = n : n = n + 1
					  Array(0,n) = UebGGP : 				n = n + 1
end if
if Exif(3) = "1" then Array(0,n) = UebBld : ExifSp(3) = n : n = n + 1
if Exif(4) = "1" then Array(0,n) = UebBZt : ExifSp(4) = n : n = n + 1
if Exif(5) = "1" then Array(0,n) = UebBKt : ExifSp(5) = n : n = n + 1
if Exif(6) = "1" then Array(0,n) = UebBrW : ExifSp(6) = n : n = n + 1
if Exif(7) = "1" then Array(0,n) = UebBli : ExifSp(7) = n : n = n + 1
if Exif(8) = "1" then Array(0,n) = UebISO : ExifSp(8) = n : n = n + 1
if Exif(9) = "1" then Array(0,n) = UebKom : ExifSp(9) = n : n = n + 1
if Exif(11) = "1" then Array(0,n) = UebGeo : ExifSp(11) = n : n = n + 1
if Exif(12) = "1" then Array(0,n) = UebBBS : ExifSp(12) = n : n = n + 1

'IPTC-Daten
if IPTC(0) = "1" then Array(0,n) = UebUeber : IPTCSp(0) = n : n = n + 1
if IPTC(1) = "1" then Array(0,n) = UebAutor : IPTCSp(1) = n : n = n + 1
if IPTC(2) = "1" then Array(0,n) = UebObjN  : IPTCSp(2) = n : n = n + 1
if IPTC(3) = "1" then Array(0,n) = UebObjB  : IPTCSp(3) = n : n = n + 1
if IPTC(4) = "1" then Array(0,n) = UebKat   : IPTCSp(4) = n : n = n + 1
if IPTC(5) = "1" then Array(0,n) = UebCop   : IPTCSp(5) = n : n = n + 1
if IPTC(6) = "1" then Array(0,n) = UebFot   : IPTCSp(6) = n : n = n + 1
if IPTC(7) = "1" then Array(0,n) = UebLand  : IPTCSp(7) = n : n = n + 1
if IPTC(8) = "1" then Array(0,n) = UebReg   : IPTCSp(8) = n : n = n + 1
if IPTC(9) = "1" then Array(0,n) = UebOrt   : IPTCSp(9) = n : n = n + 1
if IPTC(10) = "1" then Array(0,n) = UebOTeil : IPTCSp(10) = n : n = n + 1
if IPTC(11) = "1" then Array(0,n) = UebSchlW : IPTCSp(11) = n : n = n + 1

EndSpalte = n+2

end sub
'********************************************************************
Sub Tabellenerstellung
'Werteeintrag ins Array
if not BugWatch then on error resume next

Dim hoch
n = 1
Anzahl = Anzahl + 1									'Dateianzahl im Ordner
FileAnzahl = FileAnzahl + 1							'Dateianzahl gesamt
DatGross = DatGross + objFile.Size					'Dateigren gesamt

'** Allgemeine Daten
					  Array(TabZeile,n) = objFile.Name : n = n + 1	'** Dateiname
strExt = objFS.GetExtensionName(objFile.Name) 						'Datei-Extension ermitteln
if Allg(0) = "1" then Array(TabZeile,n) = UCase(strExt) : n = n + 1	'** Extension
if Allg(1) = "1" then 
	DateiGroesse = FormatNumber(objFile.Size,0)
					  Array(TabZeile,n) = DateiGroesse : n = n + 1	'** Gre
end if
if Allg(2) = "1" then
		AeDatum = objFile.DateLastModified
		If IsDate(AeDatum) then
			AeDatum = FormatDateTime(AeDatum, 2) & " " & FormatDateTime(AeDatum, 4)
		end if
					  Array(TabZeile,n) = AeDatum : n = n + 1		'** nderungsdatum
end if

'** Exif-Daten

if Ucase(strExt) = "JPG" or Ucase(strExt) = "TIF" then
	FF_LoadImage objFile										'Bild laden
	if MappMerker = "Auto" then call Mapping					'Codepage ermitteln
	
				KameraModell = FF_GetExifTag(Kamera)
		if Exif(0) = "1" then Array(TabZeile,n) = KameraModell : n = n + 1				'** Kamera
		if Exif(1) = "1" then 
				AuDatum = FF_GetExifTag(AufnDatum)
				If IsDate(AuDatum) then
					AuDatum = FormatDateTime(AuDatum, 2) & " " & FormatDateTime(AuDatum, 4)
				elseif instr(AuDatum, ":") = 5 then
					AuDatum = mid(AuDatum,9,2) & "." & mid(AuDatum,6,2) & "." & left(AuDatum,4) & mid(AuDatum,11)
				end if
							  Array(TabZeile,n) = AuDatum : n = n + 1					'** Aufnahmedatum
		end if
		if Exif(2) = "1" then
				Breite = FF_GetImageWidth()
				Hoehe = FF_GetImageHeight()
							  Array(TabZeile,n) = Breite & " x " & Hoehe : n = n + 1	'** Gre in Pixel
							  Array(TabZeile,n) = Breite * Hoehe		 : n = n + 1
		end if
		if Exif(3) = "1" then
				Info1 = FF_GetExifTagAdvanced(Blende)
				if len(Info1) > 0 then Info1 = replace(Info1,".",",") *1
							 Array(TabZeile,n) = Info1 : n = n + 1						'** Blende
		end if
		
		if Exif(4) = "1" then Array(TabZeile,n) = "'" & FF_GetExifTagAdvanced(Zeit) : n = n + 1	'** Zeit
		
		if Exif(5) = "1" then
				Info1 = FF_GetExifTag(Korrektur)
				if len(Info1) > 0 then Info1 = replace(Info1,".",",") *1
							  Array(TabZeile,n) = Info1 : n = n + 1						'** Bel.-Korrektur
		end if
		
		if Exif(6) = "1" then
			if BW_Org = 1 and BW_KB = 1 then				'Original- und KB-Brennweite
				Info1 = FF_GetExifTagAdvanced(Brennweite)
				Pos = instr(Info1,"KB:")
				if Pos = 0 then Info1 = Info1 & " (KB:-)"
				Pos = instr(Info1,".")
				if Pos > 0 then Info1 = left(Info1,Pos-1) & "," & mid(Info1,Pos+1)
			elseif BW_Org = 1 then							'nur Original-Brennweite
				Info1 = FF_GetExifTag("FocalLength")
				if len(Info1) > 0 then Info1 = replace(Info1,".",",") *1
			else											'nur Kleinbild-Brennweite
				Info1 = FF_GetExifTagAdvanced(Brennweite)
				Pos = instr(Info1,"KB:")
				if Pos > 0 then 
					Info1 = mid(Info1,Pos+3)
					Pos = instr(Info1,")")
					Info1 = left(Info1,Pos-1)
					if instr(Info1,".") > 0 then Info1 = replace(Info1,".",",") *1
				else
					Info1 = "KB fehlt"
				end if
			end if
			if Info1 = " (KB:-)" then Info1 = ""
							  Array(TabZeile,n) = Info1 : n = n + 1						'** Brennweite
		end if
		
		if Exif(7) = "1" then
				Info1 = FF_GetExifTag(Blitz)
				if len(Info1) > 0 then
					Info2 = Info1 / 2 : Info2 = Info2 - Int(Info2)
					if  Info2 > 0 then Info1 = "Ein" else Info1 = "Aus"
				end if
							  Array(TabZeile,n) = Info1 : n = n + 1						'** Blitz
		end if
		if Exif(8) = "1" then
				Info1 = FF_GetExifTag(ISO)
				if len(Info1) = 0 then Info1 = StrLeer
							  Array(TabZeile,n) = Info1	 : n = n + 1					'** ISO
		end if
		if Exif(9) = "1" then
				Kommentar = FF_MapCodePage(FF_GetExifTag("UserComment"),Codepage,0)
				if len(Kommentar) = 0 or Kommentar = vbNewLine then 
					Kommentar = StrLeer
				else
					do										'Bereinigung des Anfangs
						if asc(left(Kommentar,1)) < 32 and len(Kommentar) > 1 then
							Kommentar = mid(Kommentar,2)
						else
							exit do
						end if
					loop
					do										'Bereinigung des Endes
						if asc(right(Kommentar,1)) < 32  and len(Kommentar) > 1 then
							Kommentar = left(Kommentar,len(Kommentar)-1)
						else
							exit do
						end if
					loop
					
					if len(Kommentar) = 0 then
						Kommentar = StrLeer
					else
						KommentarElemente = split(Kommentar,vbNewLine)
						BoolZeile = false
						Kommentar = " "
						if Exif(10) = "1" then					'Kommentar einzeilig
							for each Wert in KommentarElemente
								Kommentar = Kommentar & Wert & " | "
								BoolZeile = true
							next
							if BoolZeile then Kommentar = left(Kommentar,len(Kommentar)-3)
						else									'Kommentar mehrzeilig
							for each Wert in KommentarElemente
								Kommentar = Kommentar & Wert & chr(10) & " "
								BoolZeile = true
							next
							if BoolZeile then Kommentar = left(Kommentar,len(Kommentar)-2)					
						end if
					end if
				end if
							  Array(TabZeile,n) = Kommentar	: n = n + 1	'** Kommentar
		end if
		if Exif(11) = "1" then
				Info1 = FF_GetExifTag("Latitude")
				if len(Info1) = 0 then 
					Info1 = "'--"
				else
					Info2 = FF_GetExifTag("Longitude")
					hoch  = FF_GetExifTag("Altitude")
					if len(hoch) > 0 then hoch  = chr(10) & replace(hoch,".",",") *1 & " m Hhe"

					if flag_GeoDez = "1" then
						info1 = grad2decimal(info1)
						info2 = grad2decimal(info2)
						Info1 = Info1 & "," & info2 	'& chr(10) & hoch & "m Hhe"
					else
						Info1 = Info1 & chr(10) & Info2 & hoch	'chr(10) & hoch & " m Hhe"
					end if
				end if
							  Array(TabZeile,n) = Info1	 : 	n = n + 1	'** Geodaten
		end if
		if Exif(12) = "1" then
				Info1 = FF_MapCodePage(FF_GetExifTag(Beschreibung),Codepage,0)
				if len(Info1) = 0 then 
					Info1 = StrLeer
				end if
							  Array(TabZeile,n) = Info1	 : 	n = n + 1	'** Bildbeschreibung
		end if
		
'** IPTC-Daten

		if IPTC(0) = "1" then
				Info1 = FF_MapCodePage(FF_GetIPTC(Headline),Codepage,0)
				if len(Info1) = 0 then 
					Info1 = StrLeer
				end if
							  Array(TabZeile,n) = Info1	 : 	n = n + 1	'** berschrift
		end if
		if IPTC(1) = "1" then
				Info1 = FF_MapCodePage(FF_GetIPTC(Autor),Codepage,0)
				if len(Info1) = 0 then 
					Info1 = StrLeer
				end if
							  Array(TabZeile,n) = Info1	 : 	n = n + 1	'** Autor
		end if
		if IPTC(2) = "1" then
				Info1 = FF_MapCodePage(FF_GetIPTC(Objekt),Codepage,0)
				if len(Info1) = 0 then
					Info1 = StrLeer
				end if
							  Array(TabZeile,n) = Info1	 : 	n = n + 1	'** Objektname
		end if
		if IPTC(3) = "1" then
				Info1 = FF_MapCodePage(FF_GetIPTC(ObjektB),Codepage,0)
				if len(Info1) = 0 then
					Info1 = StrLeer
				end if
							  Array(TabZeile,n) = Info1	 : 	n = n + 1	'** Obj.-Beschr.
		end if
		if IPTC(4) = "1" then
				Info1 = FF_MapCodePage(FF_GetIPTC(Kategorie),Codepage,0)
				if len(Info1) = 0 then
					Info1 = StrLeer
				end if
							  Array(TabZeile,n) = Info1	 : 	n = n + 1	'** Kategorie
		end if
		if IPTC(5) = "1" then
				Info1 = FF_MapCodePage(FF_GetIPTC(Copyright),Codepage,0)
				if len(Info1) = 0 then
					Info1 = StrLeer
				end if
							  Array(TabZeile,n) = Info1	 : 	n = n + 1	'** Copyright
		end if
		if IPTC(6) = "1" then
				Info1 = FF_MapCodePage(FF_GetIPTC(Fotograf),Codepage,0)
				if len(Info1) = 0 then
					Info1 = StrLeer
				end if
							  Array(TabZeile,n) = Info1	 : 	n = n + 1	'** Fotograf
		end if
		if IPTC(7) = "1" then
				Info1 = FF_MapCodePage(FF_GetIPTC(Land),Codepage,0)
				if len(Info1) = 0 then
					Info1 = StrLeer
				end if
							  Array(TabZeile,n) = Info1	 : 	n = n + 1	'** Land
		end if
		if IPTC(8) = "1" then
				Info1 = FF_MapCodePage(FF_GetIPTC(Region),Codepage,0)
				if len(Info1) = 0 then
					Info1 = StrLeer
				end if
							  Array(TabZeile,n) = Info1	 : 	n = n + 1	'** Region
		end if
		if IPTC(9) = "1" then
				Info1 = FF_MapCodePage(FF_GetIPTC(Ort),Codepage,0)
				if len(Info1) = 0 then 
					Info1 = StrLeer
				end if
							  Array(TabZeile,n) = Info1	 : 	n = n + 1	'** Ort
		end if
		if IPTC(10) = "1" then
				Info1 = FF_MapCodePage(FF_GetIPTC(Ortsteil),Codepage,0)
				if len(Info1) = 0 then 
					Info1 = StrLeer
				end if
							  Array(TabZeile,n) = Info1	 : 	n = n + 1	'** Ortsteil
		end if
		if IPTC(11) = "1" then
				Info1 = FF_MapCodePage(FF_GetIPTC(Schlagworte),Codepage,0)
				if len(Info1) = 0 then 
					Info1 = StrLeer
				else
					KommentarElemente = split(Info1,vbNewLine)
					BoolZeile = false
					Info1 = " "
					if Exif(10) = "1" then					'Schlagwrter einzeilig
						for each Wert in KommentarElemente
							Info1 = Info1 & Wert & " | "
							BoolZeile = true
						next
						if BoolZeile then Info1 = left(Info1,len(Info1)-3)
					else									'Schlagwrter mehrzeilig
						for each Wert in KommentarElemente
							Info1 = Info1 & Wert & chr(10) & " "
							BoolZeile = true
						next
						if BoolZeile then Info1 = left(Info1,len(Info1)-2)					
					end if
				end if
							  Array(TabZeile,n) = Info1	 : 	n = n + 1	'** Schlagwrter
		end if
end if

'Fortschrittsanzeige
if (TabZeile-1) > FortschrG then
	objExcel.ActiveSheet.Cells(4,3).Value = "Bitte warten! - " & ProzLaden & "% sind geladen"
	objExcel.Range("A1").Select
	ProzLaden = ProzLaden + ProzWert
	FortschrG = FortschrG + FortschrW
end if

end sub
'********************************************************************
function grad2decimal(ByVal p_Str)
    dim l_Richtung
    dim l_Pos
    dim l_Wert
 
    if p_Str<>"" then
        p_Str=replace(p_Str,".",",",1)
        l_Richtung=left(p_Str,1)
        p_Str=ltrim(right(p_Str,len(p_Str)-1))
        l_Pos=instr(p_Str,"")
        l_Wert=1.0*(left(p_Str,l_Pos-1))
        p_Str=ltrim(right(p_Str,len(p_Str)-l_Pos))
        l_Pos=instr(p_Str,"'")
        l_Wert=l_Wert + (left(p_Str,l_Pos-1))/60
        p_Str=ltrim(right(p_Str,len(p_Str)-l_Pos))
        l_Pos=instr(p_Str,"""")
        l_Wert=l_Wert + (left(p_Str,l_Pos-1))/3600
        Select Case l_Richtung
            Case "s", "S", "w", "W"
                grad2decimal="-" & replace(FormatNumber(l_Wert,6),",",".",1)
            case Else
                grad2decimal=replace(FormatNumber(l_Wert,6),",",".",1)
        End Select
    else
        grad2decimal=""
    end if
 
end function
'********************************************************************
Sub DateigroessenFormat
'Dateigre formatieren auf Byte, kB bzw. MB

if DatGross < 1024 then
	DatGross = DatGross & " Byte"
elseif DatGross < 1024^2 then
	DatGross = FormatNumber(DatGross / 1024,2) & " kB"
else
	DatGross = FormatNumber(DatGross / 1024^2,2) & " MB"
end if

end sub
'********************************************************************
Sub ShowSubfolder(ByVal myfolder,ByVal Tiefe)
'Eintrag der Ordnernamen in das Array
if Tiefe <= 0 or Doku(3) = "1" then	
	Pfad = myfolder.path					'wenn kompletter Pfad gewnscht, .name durch .path ersetzen
											'bei Thumbnaileintrag muss .path eingetragen sein
	BezZeile = TabZeile
	msg = string(Tiefe,">") & "  " & Pfad
	TabZeile = TabZeile + 1

	'*** Ermittlung aller Dateien  des Ordners
	Anzahl = 0
	For Each objFile In myfolder.Files										'Dateien-Auflistung
		strExt = objFS.GetExtensionName(objFile.Name) 						'Datei-Extension ermitteln
		if instr(Ucase(BFilter), Ucase(strExt)) > 0 or Doku(2) = "1" then	'alle Bilder oder alle Dateien
		if flagNFilter = 0 or instr(objFile.Name,Nfilter) > 0 then
			call Tabellenerstellung
			TabZeile = TabZeile + 1
		end if
		end if
	next
	
Array(BezZeile,0) =  LTrim(msg) & " < " & Anzahl & " Dateien >"
Kursivzeilen = Kursivzeilen & cstr(BezZeile + Zeile) & ":" & cstr(BezZeile + Zeile) & ","	
	
end if

	For Each objsubfolder In myfolder.subfolders
		ShowSubfolder objsubfolder, Tiefe + 1
	Next
	
End Sub
'********************************************************************
Sub Formatierung()
'Formatierung der Excel-Tabelle

With objExcel
    .Rows("1:1").Select
    .Selection.Font.Bold = True

    .Columns("A:A").Select
	.Selection.ColumnWidth = 1

	.Rows(cstr(Zeile) & ":" & cstr(Zeile)).Select
	.Selection.Font.Bold = True

	.Columns("B:B").Select
	.Selection.ColumnWidth = 3

	if Allg(2) = "1" then
		.Columns(chr(66+AllgSp(2)) & ":" & chr(66+AllgSp(2))).Select
		.Selection.NumberFormat = FAendDat 'fr nder.-Datum
	end if

	if Exif(1) = "1" then
		.Columns(chr(66+ExifSp(1)) & ":" & chr(66+ExifSp(1))).Select
		.Selection.NumberFormat = FAufnDat	'fr Aufn.-Datum
	end if
	
	if Exif(2) = "1" then
		.Columns(chr(67+ExifSp(2)) & ":" & chr(67+ExifSp(2))).Select
    	.Selection.NumberFormat = "#,##0"	'fr Ges.-Pixelzahl
    end if	

	if Exif(3) = "1" then					'fr Blende
		.Columns(chr(66+ExifSp(3)) & ":" & chr(66+ExifSp(3))).Select
   		.Selection.NumberFormat = "0.0"
	end if

	if Exif(5) = "1" then					'fr Bel.-Korrektur	
		.Columns(chr(66+ExifSp(5)) & ":" & chr(66+ExifSp(5))).Select
   		.Selection.NumberFormat = "0.0"
	end if

	if Exif(6) = "1" then					'fr Brennweite
		.Columns(chr(66+ExifSp(6)) & ":" & chr(66+ExifSp(6))).Select
		if BW_Org = 0 and BW_KB = 1 then
			.Selection.NumberFormat = "0"
			.Selection.HorizontalAlignment = xlRight
		else
			.Selection.NumberFormat = "0.00"
		end if
	end if

	if Exif(8) = "1" then	
		.Columns(chr(66+ExifSp(8)) & ":" & chr(66+ExifSp(8))).Select
    	.Selection.HorizontalAlignment = xlRight	'fr ISO-Wert
	end if
	
	if Exif(9) = "1" then	
		.Columns(chr(66+ExifSp(9)) & ":" & chr(66+ExifSp(9))).Select
		.Selection.ColumnWidth = 255	'fr Kommentar
		if Exif(10) = "1" then	'Exif(10) = einzeilig
    		.Selection.WrapText = True	'fr Schlagwrter (Zeilenumbruch)
    	end if
	end if	

	if Exif(11) = "1" then	
		.Columns(chr(66+ExifSp(11)) & ":" & chr(66+ExifSp(11))).Select
    	.Selection.ColumnWidth = 50	'fr Geodaten
	end if	

	if IPTC(11) = "1" and Exif(10) = "1" then	'Exif(10) = einzeilig
		.Columns(chr(66+IPTCSp(11)) & ":" & chr(66+IPTCSp(11))).Select
		.Selection.ColumnWidth = 13	'fr Schlagwrter (Zeileumbruch)
    	.Selection.WrapText = True	'fr Schlagwrter (Zeilenumbruch)
	end if	
	
	.Columns("C:AE").Select
	.Selection.Columns.AutoFit
     
    .Cells.Select
    .Selection.Rows.AutoFit
    .Selection.VerticalAlignment = xlTop
	
	Kursivzeilen = left(Kursivzeilen,len(Kursivzeilen)-1)

	KursivListe = split(Kursivzeilen,",")
	for each Element in Kursivliste
		.Rows(Element).Select
		.Selection.Font.Italic = True
	next
	   
	.Sheets("Tabelle1").Name = "Dateiliste"

end with


End Sub
'********************************************************************
Sub SeiteFormatieren

With objExcel
    With .ActiveSheet.PageSetup
        .PrintTitleRows = "$1:$5"		'Wiederholungszeilen 1 bis 5
        .PrintTitleColumns = ""
        
        .LeftFooter = "&F"				'F=Dateiname  A=Tabellenname D=aktualisiertes Datum
        .CenterFooter = ""
	    .RightFooter = "von &N Blatt &P"
	    
	  if Form(0) = "1" then
	  	.Orientation = xlPortrait		'Hochformat
	  else
        .Orientation = xlLandscape		'Querformat
      end if
      
    End With
End With

With objExcel
    With .ActiveSheet.PageSetup
    
if debugging then msgbox "Seitenrnder = " & Seit(0) & "/" & Seit(1) & "/" & Seit(2) & "/" & Seit(3)

Rand = fix(Seit(0))
if Rand < cDbl(Seit(0)) then
        .TopMargin = objExcel.Application.CentimetersToPoints(Rand+.5)		'Rand oben
        .HeaderMargin = objExcel.Application.CentimetersToPoints(Rand+.5)	'Kopfzeile
else
        .TopMargin = objExcel.Application.CentimetersToPoints(Rand)			'Rand oben
        .HeaderMargin = objExcel.Application.CentimetersToPoints(Rand)		'Kopfzeile
end if
Rand = fix(Seit(1))
if Rand < cDbl(Seit(1)) then
        .BottomMargin = objExcel.Application.CentimetersToPoints(Rand+.5)	'unten
        .FooterMargin = objExcel.Application.CentimetersToPoints(Rand)		'Fuzeile
else
        .BottomMargin = objExcel.Application.CentimetersToPoints(Rand)		'unten
        .FooterMargin = objExcel.Application.CentimetersToPoints(Rand-.5)	'Fuzeile
end if
Rand = fix(Seit(2))
if Rand < cDbl(Seit(2)) then
        .LeftMargin = objExcel.Application.CentimetersToPoints(Rand+.5)		'links
else
        .LeftMargin = objExcel.Application.CentimetersToPoints(Rand)		'links

end if
Rand = fix(Seit(3))
if Rand < cDbl(Seit(3)) then
        .RightMargin = objExcel.Application.CentimetersToPoints(Rand+.5)    'rechts
else
        .RightMargin = objExcel.Application.CentimetersToPoints(Rand)       'rechts
end if

    End With
End With
End Sub
'********************************************************************
Sub ExcelGitter()
With objExcel
    .Selection.Borders(xlDiagonalDown).LineStyle = xlNone
    .Selection.Borders(xlDiagonalUp).LineStyle = xlNone
    With .Selection.Borders(xlEdgeLeft)
        .LineStyle = xlContinuous
        .Weight = xlThin
        .ColorIndex = xlAutomatic
    End With
    With .Selection.Borders(xlEdgeTop)
        .LineStyle = xlContinuous
        .Weight = xlThin
        .ColorIndex = xlAutomatic
    End With
    With .Selection.Borders(xlEdgeBottom)
        .LineStyle = xlContinuous
        .Weight = xlThin
        .ColorIndex = xlAutomatic
    End With
    With .Selection.Borders(xlEdgeRight)
        .LineStyle = xlContinuous
        .Weight = xlThin
        .ColorIndex = xlAutomatic
    End With
    With .Selection.Borders(xlInsideVertical)
        .LineStyle = xlContinuous
        .Weight = xlThin
        .ColorIndex = xlAutomatic
    End With
    With .Selection.Borders(xlInsideHorizontal)
        .LineStyle = xlContinuous
        .Weight = xlThin
        .ColorIndex = xlAutomatic
    End With
    
    .ActiveWindow.DisplayGridlines = False
    
End With

End Sub
'********************************************************************
Sub KurzbeschreibungAnzeigen

Dim Taste
Dim BreiteKB	: BreiteKB = LaengeMax * 2.6 + 15
const Hoehe = 180

const ES_READONLY = 2048
const WS_VSCROLL = 2097152

FF_AddDialog "Kurzbeschreibung",BreiteKB,Hoehe
FF_AddControl "Kurzbeschreibung","Beschreibung","EDIT",0,0,BreiteKB,Hoehe-20
FF_SetControlStyle "Kurzbeschreibung","Beschreibung", ES_READONLY + WS_VSCROLL
FF_AddControl "Kurzbeschreibung","OK","BUTTON",BreiteKB/2-15,Hoehe-15,30,10

FF_SetControl "Kurzbeschreibung","Beschreibung",Kurzbeschreibung

do
	Taste = FF_ShowDialog("Kurzbeschreibung")
	if Taste = "CANCEL" or Taste = "OK" then exit do
loop
call FF_CloseDialog("Kurzbeschreibung")

End Sub
'------------------------------------------------------------------------
Sub KurzbeschreibungLesen
on error resume next
Const ForReading = 1
Dim Skript, Anfang, Ende, Zeile, ZZ

Set Skript = objFS.OpenTextFile(FF_GetScriptPath & "\" & SkriptName, ForReading, False)

if err.number = 53 then
	msgbox "Wahrscheinlich wurde der Originalskriptname " & """" & SkriptName & """" & " abgendert." & vbNewLine & _
		   "Die Kurzbeschreibung kann daher nicht angezeigt werden.",vbExclamation,"Meldung"
	Abbruch = True
	exit sub
end if

Do While Skript.AtEndOfStream <> True
	Zeile = Skript.ReadLine
	
	ZZ = ZZ + 1
	if ZZ > 1000 then msgbox "Fehler in der Kurzbeschreibung! (objFS?)" : exit sub
	
	if instr(Zeile,"** Ende Kurzbeschreibung") > 0 then Ende = true
	if Ende then exit do
	
	if Anfang then Kurzbeschreibung = Kurzbeschreibung & mid(Zeile,2) & vbNewLine
	if len(Zeile)-1 > LaengeMax then LaengeMax = len(Zeile)-1
	
	if instr(Zeile,"** Start Kurzbeschreibung") > 0 then Anfang = true
	
Loop
	
if Anfang and Ende then KBvorhanden = true
Skript.Close

End Sub
'------------------------------------------------------------------------
Sub KillSkript
'Skript mit allen Komponenten entfernen

Dim SPfad
const RegSchluessel = "\FF_Doku-Excel\"

'### FixFotoScript.ini bereinigen
TempFile = FF_GetFFPathEx(1) & "\FixFotoScript.ini"
if objFS.FileExists(TempFile) then
	call IniBereinigung
	if Abbruch then exit sub
else
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht gefunden werden." & vbNewLine & _
			"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'### zip-Archiv auf Wunsch sichern, dann lschen
TempFile = FF_GetScriptPath & "\" & objFS.GetBaseName(Skriptname) & ".zip"
if objFS.FileExists(TempFile) then
	Antwort = msgbox("Soll das Archiv " & objFS.GetBaseName(Skriptname) & ".zip" & _
			 " gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skripts wird abgebrochen!",vbExclamation,"Hinweis"
			exit sub
		end if
		SPfad = SPfad & "\" & objFS.GetBaseName(Skriptname) & ".zip"
		objFS.CopyFile Tempfile, SPfad, true
	end if
	objFS.DeleteFile TempFile,true
end if

'### Skriptdatei lschen
TempFile = FF_GetScriptPath & "\" & Skriptname
objFS.DeleteFile TempFile,true

'### evtl. beigepackte bzw. erzeugte Dateien und Ordner lschen
'TempFile = FF_GetScriptPath & "\Beipack.txt"					'Datei
'if objFS.FileExists(TempFile) then objFS.DeleteFile TempFile,true

TempFile = FF_GetScriptPath & "\MeckiScript\ImageInfo_To_Excel"	'Ordner
if objFS. FolderExists (TempFile) then objFS. DeleteFolder TempFile,true

'### Registry-Daten lschen
TempFile = "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script" & RegSchluessel
WshShell.RegDelete(TempFile)

'### Fertigmeldung
msgbox "Nach Durchfhrung der 'Automatischen Skriptkonfiguration' ist das Skript" & vbNewLine & _
		Skriptname & " mit allen Komponenten gelscht!",vbExclamation,"Hinweis"
End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung

Dim Zeile, zNr,Anfang, Ende, DateiTmp, ZielZeile, tmpString
DateiTmp =  FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'### Wo befindet sich der Eintrag zum Skript?
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if tmpString = "[Script]" then Anfang = zNr
	if tmpString = "File=.\" & Skriptname then
		Ende = zNr
		exit do	
	end if
loop 
Zeile.Close

if Ende <= Anfang then
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht bereinigt werden." & vbNewLine & _
		"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

'### Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)
Set ZielZeile  = objFS.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < Anfang or zNr > Ende then
		ZielZeile.WriteLine tmpString
	end if
loop 

Zeile.Close
ZielZeile.Close

'### Umkopieren von DateiTmp nach FixFotoScript.ini (TempFile)
objFS.CopyFile DateiTmp, TempFile, True
objFS.DeleteFile (DateiTmp)

End Sub
'------------------------------------------------------------------------
Sub ThumbnailEintrag
Dim Datei,Verzeichnis,Extension,Zeile,Pos
Dim HoeheThumb,BreiteThumb,tDatei

tDatei = tOrdner & "\Thumbnail.jpg"

Zeile = 6
With objExcel
	do
		Datei = .ActiveSheet.Cells(Zeile,3).Value
		if Datei = "" then
			Verzeichnis = .ActiveSheet.Cells(Zeile,2).Value
			
			if Verzeichnis = "" then exit do
			
			Pos = InStr(Verzeichnis,"> ")
			if Pos > 0 then Verzeichnis = mid(Verzeichnis,Pos+1)
			
			Pos = InStrRev(Verzeichnis," <")
			if Pos > 0 then Verzeichnis = left(Verzeichnis,Pos-1)
			
			Zeile = Zeile + 1
			Datei = .ActiveSheet.Cells(Zeile,3).Value
			Datei = trim(Verzeichnis & "\" & Datei)
		else
			Datei = trim(Verzeichnis & "\" & Datei)
		end if

		Pos = InStrRev(Datei,".")
		if Pos > 0 then Extension = mid(Datei,Pos+1)
		if instr(Ucase(BFilter),Ucase(Extension)) > 0 then
		if flagNFilter = 0 or instr(Datei,Nfilter) > 0 then

'			FF_LoadThumb Datei								'gendert ab V 4.06 / statt Thumbnail jetzt Originaldatei
			FF_LoadImage Datei								'gendert ab V 4.06 / geladen und
			FF_HQScale Thn_langeSeite,Thn_langeSeite,true	'gendert ab V 4.06 / skaliert
			
			FF_YSharp 20
			FF_Sharp 20,true,true,true
			FF_KillExif : FF_KillIPTC
			FF_SaveImage tDatei,75
			
			HoeheThumb  = FF_GetImageFileHeight(tDatei)
			BreiteThumb = FF_GetImageFileWidth(tDatei)
			
			.Range("C" & cstr(Zeile)).Select
			.ActiveCell.AddComment							'Kommentar hinzufgen
			.ActiveCell.Comment.Text " "					'Kommentartext lschen
			.ActiveCell.Comment.Shape.Fill.UserPicture tDatei	'Bild in Kommentar einfgen
			.ActiveCell.Comment.Shape.Height = HoeheThumb	'Hhe des Kommentarfeldes
			.ActiveCell.Comment.Shape.Width = BreiteThumb	'Breite des Kommentarfeldes
		end if
		end if
		
		Zeile = Zeile + 1
		
	loop
	
	.Range("A1").Select
	
End with

End Sub
'------------------------------------------------------------------------
Sub Mapping
Dim Escape

Codepage = ""
Escape = FF_GetIPTC("Characterset")             ' Codepage auslesen

if Len(Escape) <> 0 then                        ' es stehen Codepage-Informationen zur Verfgung
    Escape = Right(Escape, 2)                   ' Escape-Zeichen abschneiden
    Select Case Escape
        Case HxAnsi(25) & HxAnsi(73)            ' MacRoman
            Codepage = 10000
        Case HxAnsi(25) & HxAnsi(47)            ' UTF-8
            Codepage = 65001
        Case HxAnsi(28) & HxAnsi(42)            ' US-ASCII
            Codepage = 20127
        Case HxAnsi("2C") & HxAnsi(41)          ' ISO-8859-1
            Codepage = 28591
        Case HxAnsi("2D") & HxAnsi(41)
            Codepage = 28591
        Case HxAnsi("2E") & HxAnsi(41)
            Codepage = 28591
        Case HxAnsi("2F") & HxAnsi(41)
            Codepage = 28591
        Case HxAnsi("2C") & HxAnsi(62)          ' ISO-8859-15
            Codepage = 28605
        Case HxAnsi("2D") & HxAnsi(62)
            Codepage = 28605
        Case HxAnsi("2E") & HxAnsi(62)
            Codepage = 28605
        Case HxAnsi("2F") & HxAnsi(62)
            Codepage = 28605
    End Select
end if

if len(Codepage) = 0 then Codepage = 28605

End sub
'-----------------------------------------------------------------------
Function HxAnsi (strHex)
' ** wandelt Hez-Zahl in das korrespondiernede ANSI-Zeichen
    HxAnsi = Chr(CLng("&H" & strHex))
End Function
'-----------------------------------------------------------------------
Function Version_OK(MinVersion)
dim VersNr

 VersNr=split(MinVersion,".")
 Version_OK=FF_GetMajor * 1000 + FF_GetMinor + FF_GetBuild / 1000 >=_
     		VersNr(0) * 1000 + VersNr(1) + VersNr(2) / 1000

End Function
'------------------------------------------------------------------------
'************************************************************************
'Update-Funktion
'************************************************************************
Sub Update
Dim Antwort

call Versionsermittlung_url

if not Abbruch then
	SkriptV_Zahl = Replace(SkriptVersion,".","") *1
	
	if UrlV_Zahl = SkriptV_Zahl then
		msgbox "Die Version " & SkriptVersion & " ist aktuell!",vbInformation,"Versionsmeldung"
	elseif SkriptV_Zahl < UrlV_Zahl then
		Antwort = msgbox("Die Skriptversion " & SkriptVersion & " ist nicht mehr aktuell!" & vbNewLine &_
				"Es steht die Version " & UrlVersion & " zum Download bereit." & vbNewLine & vbNewLine & _
				"Soll die Downloadseite aufgerufen werden?",vbQuestion + vbYesNo,"Versionsmeldung")
		if Antwort = vbYes then
			on error resume next
			WshShell.Run SkriptUrl,1,false
			if err <> 0 then
				msgbox "Die Downloadseite wurde nicht gefunden!",vbExclamation,"Hinweis"
			else
				SkriptEnde = true
			end if
			on error goto 0
		end if
	else
		msgbox 	"Es liegt ein Fehler in den Versionsangaben vor." & vbNewLine &_
				"Die Skriptversion " & SkriptVersion & " ist grer als die auf" & vbNewLine &_
				"der Downloadseite angegebene Version " & UrlVersion & ".",vbInformation,"Fehlermeldung"
	end if
end if

End Sub
'------------------------------------------------------------------------
Sub Versionsermittlung_url

Dim Inhalt,Start,Zeit,pos1,pos2,n
Dim xml, Fehler
Fehler = false

on error resume next
Set xml = CreateObject("Microsoft.XMLHTTP")
xml.Open "Get",SkriptUrl,false
xml.Send

Inhalt = xml.responseText

if err > 0 then
	Fehler = true
else
	'Version suchen und anzeigen
	pos1 = instr(Inhalt,"Version:")
	if pos1 > 0 then
	
		pos2 = instr(pos1 ,Inhalt,"<br")
		if pos2 > 0 then
			UrlVersion = trim(mid(Inhalt,pos1,pos2-pos1))
			'Msgbox "Aktuell ist die " & UrlVersion,vbInformation,"Information"
		else
			Fehler = true
		end if
	else
		Fehler = true
	end if
end if

Set xml = nothing

if Fehler then
	msgbox  "Die Versionsangabe wurde nicht gefunden!" & vbNewLine &_
			"Mglicherweise funktioniert der Internetaufruf nicht." & vbNewLine & vbNewLine & _
			"Am besten nochmal probieren!",vbExclamation,"Fehlermeldung"
	Abbruch = true
	exit sub
end if

'Version als Zahl
pos1 = instr(UrlVersion," ")
if pos1 = 0 then pos1 = 7
UrlVersion = trim(mid(UrlVersion,pos1+1))
UrlV_Zahl = Replace(UrlVersion,".","") *1

End Sub
'------------------------------------------------------------------------
